【问题描述】[中等]
根据每日 气温 列表,请重新生成一个列表,对应位置的输出是需要再等待多久温度才会升高超过该日的天数。如果之后都不会升高,请在该位置用 0 来代替。
例如,给定一个列表 temperatures = [73, 74, 75, 71, 69, 72, 76, 73],你的输出应该是 [1, 1, 4, 2, 1, 1, 0, 0]。
提示:气温 列表长度的范围是 [1, 30000]。每个气温的值的均为华氏度,都是在 [30, 100] 范围内的整数。
【解答思路】
1. 暴力
- 新建数组
- 遍历找到比当前位置i大的 坐标相减 没找到 赋值0
时间复杂度:O(N^2) 空间复杂度:O(1)
int len = T.length;
if(len == 0 || len ==1){
return new int[1];
}
int[] high = new int[len];
high[len-1]=0;
for(int i=0;i<len-1;i++){
for(int j=i+1;j<len;j++){
if(T[j]>T[i]){
high[i] = j-i;
break;
}
if(j==len-1 &&(T[len-1]<=T[i]) ){
high[i]=0;
}
}
}
return high;
}
public int[] dailyTemperatures(int[] T) {
int[] res = new int[T.length];
for (int i = 0; i < T.length; i++) {
int j = i + 1;
while (j < T.length && T[i] >= T[j]) {
j++;
}
res[i] = j < T.length && T[i] < T[j] ? j - i : 0;
}
return res;
}
2. 单调栈
时间复杂度:O(N) 空间复杂度:O(N)
public int[] dailyTemperatures(int[] T) {
int length = T.length;
int[] ans = new int[length];
Deque<Integer> stack = new LinkedList<Integer>();
for (int i = 0; i < length; i++) {
int temperature = T[i];
while (!stack.isEmpty() && temperature > T[stack.peek()]) {
int prevIndex = stack.pop();
ans[prevIndex] = i - prevIndex;
}
stack.push(i);
}
return ans;
}
【总结】
1.暴力优化 单调栈解决柱状图高低比较问题
2.单调栈
出栈都要做的判断!stack.isEmpty()
转载参考链接:https://leetcode-cn.com/problems/daily-temperatures/solution/mei-ri-wen-du-by-leetcode-solution